PipeWire: impl-client.c File Reference

PipeWire 0.3.7

Data Structures | Macros | Functions
impl-client.c File Reference
Include dependency graph for impl-client.c:

## Data Structures
struct | error_data

## Macros
#define | NAME "client"

## Functions
SPA_EXPORT int | pw_impl_client_register (struct pw_impl_client *client, struct pw_properties *properties)
| Finish configuration and register a client. More...
SPA_EXPORT struct pw_context * | pw_impl_client_get_context (struct pw_impl_client *client)
| Get the context used to create this client. More...
SPA_EXPORT struct pw_protocol * | pw_impl_client_get_protocol (struct pw_impl_client *client)
| Get the protocol used to create this client. More...
SPA_EXPORT struct pw_resource * | pw_impl_client_get_core_resource (struct pw_impl_client *client)
| Get the client core resource. More...
SPA_EXPORT struct pw_resource * | pw_impl_client_find_resource (struct pw_impl_client *client, uint32_t id)
| Get a resource with the given id. More...
SPA_EXPORT struct pw_global * | pw_impl_client_get_global (struct pw_impl_client *client)
| Get the global associated with this client. More...
SPA_EXPORT const struct pw_properties * | pw_impl_client_get_properties (struct pw_impl_client *client)
| Get the client properties. More...
SPA_EXPORT void * | pw_impl_client_get_user_data (struct pw_impl_client *client)
| Get the client user data. More...
SPA_EXPORT void | pw_impl_client_add_listener (struct pw_impl_client *client, struct spa_hook *listener, const struct pw_impl_client_events *events, void *data)
| listen to events from this client More...
SPA_EXPORT const struct pw_client_info * | pw_impl_client_get_info (struct pw_impl_client *client)
| Get the client information. More...
SPA_EXPORT int | pw_impl_client_update_permissions (struct pw_impl_client *client, uint32_t n_permissions, const struct pw_permission *permissions)
| Update the client permissions. More...
SPA_EXPORT void | pw_impl_client_set_busy (struct pw_impl_client *client, bool busy)
| Mark the client busy. More...

## Macro Definition Documentation

## ◆ NAME

#define NAME "client"

## Function Documentation

## ◆ pw_impl_client_add_listener()

SPA_EXPORT void pw_impl_client_add_listener | ( | struct pw_impl_client * | client,
|  | struct spa_hook * | listener,
|  | const struct pw_impl_client_events * | events,
|  | void * | data
| ) |  |

listen to events from this client

## ◆ pw_impl_client_find_resource()

SPA_EXPORT struct pw_resource* pw_impl_client_find_resource | ( | struct pw_impl_client * | client,
|  | uint32_t | id
| ) |  |

Get a resource with the given id.

References pw_map::pw_map_lookup().

## ◆ pw_impl_client_get_context()

SPA_EXPORT struct pw_context* pw_impl_client_get_context | ( | struct pw_impl_client * | client | ) |

Get the context used to create this client.

## ◆ pw_impl_client_get_core_resource()

SPA_EXPORT struct pw_resource* pw_impl_client_get_core_resource | ( | struct pw_impl_client * | client | ) |

Get the client core resource.

## ◆ pw_impl_client_get_global()

SPA_EXPORT struct pw_global* pw_impl_client_get_global | ( | struct pw_impl_client * | client | ) |

Get the global associated with this client.

## ◆ pw_impl_client_get_info()

SPA_EXPORT const struct pw_client_info* pw_impl_client_get_info | ( | struct pw_impl_client * | client | ) |

Get the client information.

## ◆ pw_impl_client_get_properties()

SPA_EXPORT const struct pw_properties* pw_impl_client_get_properties | ( | struct pw_impl_client * | client | ) |

Get the client properties.

## ◆ pw_impl_client_get_protocol()

SPA_EXPORT struct pw_protocol* pw_impl_client_get_protocol | ( | struct pw_impl_client * | client | ) |

Get the protocol used to create this client.

## ◆ pw_impl_client_get_user_data()

SPA_EXPORT void* pw_impl_client_get_user_data | ( | struct pw_impl_client * | client | ) |

Get the client user data.

## ◆ pw_impl_client_register()

SPA_EXPORT int pw_impl_client_register | ( | struct pw_impl_client * | client,
|  | struct pw_properties * | properties
| ) |  |

Finish configuration and register a client.

References NAME, pw_global::pw_global_new(), PW_KEY_ACCESS, PW_KEY_MODULE_ID, PW_KEY_PROTOCOL, PW_KEY_SEC_GID, PW_KEY_SEC_LABEL, PW_KEY_SEC_PID, PW_KEY_SEC_UID, pw_log::pw_log_debug, pw_properties::pw_properties_new(), pw_properties::pw_properties_update_keys(), PW_TYPE_INTERFACE_Client, and PW_VERSION_CLIENT.

## ◆ pw_impl_client_set_busy()

SPA_EXPORT void pw_impl_client_set_busy | ( | struct pw_impl_client * | client,
|  | bool | busy
| ) |  |

Mark the client busy.

This can be used when an asynchronous operation is started and no further processing is allowed to happen for the client

References NAME, and pw_log::pw_log_debug.

## ◆ pw_impl_client_update_permissions()

SPA_EXPORT int pw_impl_client_update_permissions | ( | struct pw_impl_client * | client,
|  | uint32_t | n_permissions,
|  | const struct pw_permission * | permissions
| ) |  |

Update the client permissions.

References pw_permission::id, NAME, pw_permission::permissions, pw_context_find_global(), pw_global_update_permissions(), PW_ID_ANY, pw_log::pw_log_debug, pw_log::pw_log_warn, and PW_PERM_INVALID.